#version 150

#moj_import <light.glsl>
#moj_import <fog.glsl>

uniform sampler2D Sampler0;

uniform vec4 ColorModulator;
uniform float FogStart;
uniform float FogEnd;
uniform vec4 FogColor;

uniform vec3 Light0_Direction;
uniform vec3 Light1_Direction;

in float vertexDistance;
in vec4 vertexColor;
in vec4 lightColor;
in vec4 overlayColor;
in vec2 texCoord;
in vec2 texCoord2;
in vec3 Pos;
in float zpos;
in float transition;

flat in int isCustom;
flat in int isGUI;
flat in int isHand;
flat in int noshadow;
flat in int damage_tint;
in vec2 texCoord0;

out vec4 fragColor;

bool roughly_equal(float num1, float num2, float threshold) {
    return abs(num1 - num2) <= threshold;
}

void main() {
    vec4 color = mix(texture(Sampler0, texCoord), texture(Sampler0, texCoord2), transition);

//<Roger_Swiffer_Cleaner> Oh. we have to choose which one we want. ok
	float alpha2 = textureLod(Sampler0, texCoord, 0.0).a * 255.0; // Take the alpha from the texture's LOD so it doesn't have any issues (this has hurt me before with VDE)
//	float alpha100 = textureLod(Sampler0, texCoord0, 0.0).a * 100.0; // Added to make it easier to work with for more image editors
	
    if (color.a < 0.1) discard; // Snipped due to size.
	
    // updated to 1.19.4 thanks to the der discohund

    // Switch used parts of the texture depending on where the model is displayed
//    if (isGUI == 0 && roughly_equal(alpha2, 253.0, 0.01)) discard;
//    if (isGUI == 1) {
             if (zpos  > 125.0 && roughly_equal(alpha2, 254.0, 0.01)) discard;     // Handled as inventory slot
        else if (zpos <= 125.0 && roughly_equal(alpha2, 253.0, 0.01)) discard; // Handled as on the player doll
//    }

    //custom lighting
    #define ENTITY
    #moj_import<objmc_light.glsl>

    if (color.a < 0.01) discard;
    fragColor = linear_fog(color, vertexDistance, FogStart, FogEnd, FogColor);
}
